import java.nio.charset.StandardCharsets
import com.sun.jersey.api.client.Client
import com.sun.jersey.api.client.ClientResponse
import com.sun.jersey.api.client.WebResource
import com.sun.jersey.core.util.Base64

object DataRecorderServiceExample {

  def main( args: Array[String] ): Unit = {

    val proxyHost: String = "rb-proxy-de.bosch.com"
    val proxyPort: String = "8080"

    val resourceUrl: String = "https://bosch-iot-insights.com/data-recorder-service/v2/"
    val sfdeProject: String = "demo"

    val username: String = "your_username"
    val password: String = "your_password"
    val authorizationCredentials: String = generateAuthorizationToken( username, password )

    val contentType: String = "text/plain"
    val payload: String = "Hello World"

    System.setProperty( "https.proxyHost", proxyHost )
    System.setProperty( "https.proxyPort", proxyPort )

    val service: WebResource = Client.create().resource( resourceUrl + sfdeProject )
    val response: ClientResponse = service.header( "Authorization", authorizationCredentials )
      .header( "Content-Type", contentType )
      .post( classOf[ClientResponse], payload )

    println( response )
  }

  private def generateAuthorizationToken( username: String, password: String ): String =
    "Basic " + new String( Base64.encode(username + ":" + password), StandardCharsets.UTF_8 )

}